diff --git a/src/civetweb.c b/src/civetweb.c
index 245182e6d..145757914 100644
--- a/src/civetweb.c
+++ b/src/civetweb.c
@@ -7955,8 +7955,8 @@ remove_dot_segments(char *inout)
 				/* remove last segment */
 				do {
 					out_end--;
-					*out_end = 0;
 				} while ((out_begin != out_end) && (*out_end != '/'));
+				*out_end = 0;
 			}
 		} else if (!strcmp(in, "/..")) {
 			in[1] = 0;
@@ -7964,8 +7964,8 @@ remove_dot_segments(char *inout)
 				/* remove last segment */
 				do {
 					out_end--;
-					*out_end = 0;
 				} while ((out_begin != out_end) && (*out_end != '/'));
+				*out_end = 0;
 			}
 		}
 		/* otherwise */
diff --git a/unittest/private.c b/unittest/private.c
index 3cfa6d8ff..82f0deb50 100644
--- a/unittest/private.c
+++ b/unittest/private.c
@@ -331,51 +331,59 @@ START_TEST(test_remove_dot_segments)
 	struct {
 		const char *input;
 		const char *expected_output;
-	} tests[] = {{"/path/to/file.ext", "/path/to/file.ext"},
-	             {"/file.ext", "/file.ext"},
-	             {"/path/../file.ext", "/file.ext"},
-	             {"/../to/file.ext", "/to/file.ext"},
-	             {"/../../file.ext", "/file.ext"},
-	             {"/./../file.ext", "/file.ext"},
-	             {"/.././file.ext", "/file.ext"},
-	             {"/././file.ext", "/file.ext"},
-	             {"/././file.ext", "/file.ext"},
-	             {"/path/.to/..file.ext", "/path/.to/..file.ext"},
-	             {"/file", "/file"},
-	             {"/path/", "/path/"},
-
-	             {"file.ext", "file.ext"},
-	             {"./file.ext", "file.ext"},
-	             {"../file.ext", "file.ext"},
-	             {".file.ext", ".file.ext"},
-	             {"..file.ext", "..file.ext"},
-	             {"file", "file"},
-	             {"/x/../", "/"},
-	             {"/x/../../", "/"},
-	             {"/x/.././", "/"},
-	             {"/./x/.././", "/"},
-
-	             /* Windows specific */
-	             {"\\file.ext", "/file.ext"},
-	             {"\\..\\file.ext", "/file.ext"},
-	             {"/file.", "/file"},
-	             {"/path\\to.\\.\\file.", "/path/to/file"},
-
-	             /* Multiple dots and slashes */
-	             {"\\//\\\\x", "/x"},
-	             {"//", "/"},
-	             {"/./", "/"},
-	             {"/../", "/"},
-	             {"/.../", "/"},
-	             {"/..../", "/"},
-	             {"/...../", "/"},
-	             {"/...../", "/"},
-	             {"/...//", "/"},
-	             {"/..././", "/"},
-	             {"/.../../", "/"},
-	             {"/.../.../", "/"},
-
-	             {NULL, NULL}};
+	} tests[] = {
+	    {"/path/to/file.ext", "/path/to/file.ext"},
+	    {"/file.ext", "/file.ext"},
+	    {"/path/../file.ext", "/file.ext"},
+	    {"/../to/file.ext", "/to/file.ext"},
+	    {"/../../file.ext", "/file.ext"},
+	    {"/./../file.ext", "/file.ext"},
+	    {"/.././file.ext", "/file.ext"},
+	    {"/././file.ext", "/file.ext"},
+	    {"/././file.ext", "/file.ext"},
+	    {"/path/.to/..file.ext", "/path/.to/..file.ext"},
+	    {"/file", "/file"},
+	    {"/path/", "/path/"},
+
+	    {"file.ext", "file.ext"},
+	    {"./file.ext", "file.ext"},
+	    {"../file.ext", "file.ext"},
+	    {".file.ext", ".file.ext"},
+	    {"..file.ext", "..file.ext"},
+	    {"file", "file"},
+	    {"/x/../", "/"},
+	    {"/x/../../", "/"},
+	    {"/x/.././", "/"},
+	    {"/./x/.././", "/"},
+
+	    /* Windows specific */
+	    {"\\file.ext", "/file.ext"},
+	    {"\\..\\file.ext", "/file.ext"},
+	    {"/file.", "/file"},
+	    {"/path\\to.\\.\\file.", "/path/to/file"},
+
+	    /* Multiple dots and slashes */
+	    {"\\//\\\\x", "/x"},
+	    {"//", "/"},
+	    {"/./", "/"},
+	    {"/../", "/"},
+	    {"/.../", "/"},
+	    {"/..../", "/"},
+	    {"/...../", "/"},
+	    {"/...../", "/"},
+	    {"/...//", "/"},
+	    {"/..././", "/"},
+	    {"/.../../", "/"},
+	    {"/.../.../", "/"},
+
+	    /* Test cases from issues */
+	    {"/foo/bar/baz/../qux.txt", "/foo/bar/qux.txt"},
+	    {"/../alice/bob/../carol/david/frank/../../grace.ext/hugo/../irene.jpg",
+	     "/alice/carol/grace.ext/irene.jpg"},
+	    {"/a/b/..", "/a/"},
+	    {"/a/b/c/../d/../..", "/a/"},
+
+	    {NULL, NULL}};
 
 	mark_point();
 
